#!/usr/bin/perl 

package KShieldCustomerAuthDB ;
use Kernel::System::CustomerAuth::DB ;
@ISA = qw (Kernel::System::CustomerAuth::DB) ;

use KShieldClient ;

sub new {
	my($class) = shift;
  my(%params) = @_;
  my($Self) = Kernel::System::CustomerAuth::DB->new(@_);
	

	my $ConfigObject = $Kernel::OM->Get('Kernel::Config');

  $Self->{serverURL} = $ConfigObject->Get( 'Customer::AuthModule::KShield::ServerURL' . $Param{Count} );
  $Self->{APIKey} = $ConfigObject->Get( 'Customer::AuthModule::KShield::APIKey' . $Param{Count} );
  $Self->{kshieldUserAttr} = $ConfigObject->Get( 'Customer::AuthModule::KShield::UserAttr' . $Param{Count} );
	
  return (bless($Self, $class));
}

sub ObtainKShieldUID {
	my($Self) = @_ ;
	
	$wst = new KShieldClient($Self->{serverURL}, $Self->{APIKey}, $Self->{kshieldUserAttr}) ;
	
	my $RemoteAddr = $ENV{REMOTE_ADDR} ;
	
	return $wst->getByIP($RemoteAddr) ;
}

sub CheckUsername {
  my ($Self, $Username) = @_ ;
  
  #my $SQL = "SELECT $Self->{UserTableUserID}, $Self->{UserTableUser} "
  #      . " FROM "
  #      . " $Self->{UserTable} "
  #      . " WHERE "
  #      . " valid_id IN ( ${\(join ', ', $Kernel::OM->Get('Kernel::System::Valid')->ValidIDsGet())} ) AND "
  #      . " $Self->{UserTableUser} = '" . $DBObject->Quote($Username) . "'";
  #$DBObject->Prepare( SQL => $SQL );
  
  #while ( my @Row = $DBObject->FetchrowArray() ) {
  #  return 1 ;
  #}
  
  $Self->{DBObject}->Prepare(
        SQL => "
            SELECT $Self->{Key} FROM $Self->{Table} WHERE
            $Self->{Key} = '$Username'
            ");

    while ( my @Row = $Self->{DBObject}->FetchrowArray() ) {
        return 1;
    }
  
  return;
}

sub GetOption {
  my ($Self, %Param) = @_ ;
	
	my $uid = $Self->ObtainKShieldUID ;
	
  my $fdn =  $uid -> {fdn} ;
	my $screenName = $uid -> {screenName} ;
	
	if ($fdn && $Self->CheckUsername($screenName)) {
		my %Option = ( PreAuth => 1, );
		return $Option{ $Param{What} };
	}
	
	return $Self->SUPER::GetOption(%Param) ;
}

sub Auth {
  my ( $Self, %Param ) = @_;

	my $uid = $Self->ObtainKShieldUID ;
	my $fdn = $uid -> {fdn} ;
  my $screenName = $uid -> {screenName} ;
	
	if (!$Param{Pw} && $fdn && $Self->CheckUsername($screenName)) {
		return $screenName ;
	}
	
	return $Self->SUPER::Auth(%Param) ;
}

1;